class DetailTaskView {
  constructor(element){
    this.element = element
    this.fields = {
      done: this.element.querySelector("[name=done]"),
      description: this.element.querySelector("[name=description]")
    }

    this.fields.description.addEventListener("input", () => {
      this.task.description = this.fields.description.value
    })

    this.fields.done.addEventListener("change", () => {
      this.task.done = this.fields.done.checked
    })

    this.deleteButton = this.element.querySelector("#delete_button")

    this.deleteButton.addEventListener("click", () => {
      let summary_view_for_deleted_task = task_views.find((summary_view) => summary_view.task === this.task)
      
      task_views.remove(summary_view_for_deleted_task)
      tasks.remove(this.task)

      list.removeChild(summary_view_for_deleted_task.element)

    })
  }

  get task(){
    return this._task
  }

  set task(new_task){
    this._task = new_task
    this._task.addEventListener("change", () => this.update())
    this.update()
  }

  update() {
    this.fields.done.checked = this.task.done
    this.fields.description.value = this.task.description
  }
}

export default DetailTaskView